Subject: [bug#62274] [PATCH] home: 'home-environment-with-provenance' uses the HE location info.

From: Andrew Tropin <[email-masked]>
Date: Tue, 21 Mar 2023 17:38:47 +0400

On 2023-03-21 13:22, Sergey Trofimov wrote:

> Hi Andrew,
>
> Andrew Tropin <[email-masked]> writes:
>
>> [[PGP Signed Part:Undecided]]
>> On 2023-03-20 20:03, Sergey Trofimov wrote:
>>
>>>
>>> You're right, the new signature is not used anywhere yet. 
>>> Though
>>> I'm working on a patch to embed home profiles in disk images
>>> produced with `guix system image`. That's where this method 
>>> comes
>>> handy, see example usage:
>>>
>>
>> Also, take a look at this thread:
>> https://yhetil.org/[email-masked]
>>
>> and this prototype:
>> https://git.sr.ht/~abcdw/rde/tree/044de83e980b7038b87d27a090aef24229df85eb/src/gnu/services/home.scm#L1
>>
>> It can be related to what you want to achieve, whithout 
>> modifying
>> image-related code.
>
> Brilliant! That's it. It didn't come to me that `home-environment` 
> could be a dependency of `operating-system` and not of the image 
> itself. And you also made the service to activate it, so no manual 
> step is required. That's exactly what I have envisioned. What 
> prevents you to mainline it? It seems you have already 
> battle-tested it.
>
> The only concern is that I'd rather include 
> `guix-home-service-type` only in the first generation of the 
> system. I think that this tie between user envs and the operating 
> system makes sense only on the first boot. Later on the users 
> should be responsible (and able to) to maintain their environments 
> independently.

There are a few issues I've not addressed yet:

1. User can login before activation finished. (Discussed in the
mentioned thread above).

2. Do we need to activate it on every system reconfigure? (Actually, I
used it mostly for creating rde live cd and vm images, so didn't test
much with system reconfigure or guix deploy. Also, I guess it would be
cool to add a one-shot? flag to the service for skeleton like
functionality/initial provisioning).

3. Probably something else I already forgot.

I still don't have enough spare time to clean it up, test and upstream,
but if you would like to finish this thing up, I would be very happy to
help!

-- 
Best regards,
Andrew Tropin